#!/bin/sh
export REPO=file://`pwd`/testrepo

# Create a local SVN repository with a vendor area 
svnadmin create testrepo
svn mkdir ${REPO}/trunk -m 'Make trunk'
svn mkdir ${REPO}/branches -m 'Make branches'
svn mkdir ${REPO}/tags -m 'Make tags'
svn mkdir ${REPO}/vendor -m 'Make vendor'

# Check out the trunk and vendor area
svn co ${REPO}/trunk
svn co ${REPO}/vendor

# Create a directory in the vendor tree that contains a file
cd vendor
mkdir d
cd d
echo line1 >> c
cd ..
svn add d
svn ci -m 'Made vendor/d/c'

# Copy the directory from the vendor area, and then modify the file within
# Has to be a URL->PATH copy to reproduce the bug
cd ../trunk
svn cp ${REPO}/vendor/d .
cd d
echo line2 >> c
cd ..
svn ci -m 'Modify with copy'

# Clone the repository with HGSubversion
cd ..
hg clone ${REPO} test.hg