#!/bin/sh

echo "* Creating repo and working copy"
rm -rf repo work hg-clone
mkdir repo work
svnadmin create repo/test
svn co file://`pwd`/repo/test work/test

echo ""
echo "* Creating structure"
cd work/test
mkdir tags branches trunk
svn add tags branches trunk
svn ci -m "structure"

echo ""
echo "* Adding foobar file"
echo "hello world" > trunk/foobar
svn add trunk/foobar
svn ci -m "added foobar"

echo ""
echo "* Creating base test_tag"
mkdir tags/test_tag
svn add tags/test_tag
svn ci -m "add test_tag"

echo ""
echo "* Tagging from trunk to test_tag"
cd ../..
svn cp file://`pwd`/repo/test/trunk file://`pwd`/repo/test/tags/test_tag/trunk  -m "tag from trunk to test_tag"
cd -

echo ""
echo "* Make branches dir under test_tag"
mkdir tags/test_tag/branches
svn add tags/test_tag/branches
svn ci -m "adding branches under test_tag"

echo ""
echo "* Copy from trunk tag to new branches tag"
cd ../..
svn cp file://`pwd`/repo/test/tags/test_tag/trunk file://`pwd`/repo/test/tags/test_tag/branches/test_branch  -m "copy from tagged trunk to tagged branch"
cd -

echo ""
echo "* Update to latest revision"
svn up

echo ""
echo "* Delete test_tag"
svn rm tags/test_tag
svn ci -m "deleted test_tag"

echo ""
echo "* Create nested tags"
mkdir -p tags/test_tag/tags/test_tag
svn add tags/test_tag
svn ci -m "created nested tags"

echo ""
echo "* Copy tagged trunk @r4 into nested tags"
cd ../..
svn cp file://`pwd`/repo/test/tags/test_tag/trunk@4 file://`pwd`/repo/test/tags/test_tag/tags/test_tag -m "copy from tagged trunk @r4 to nested tag branch"
cd -

echo ""
echo "* Create branches under tag"
mkdir -p tags/test_tag/branches/test_branch
svn add tags/test_tag/branches
svn ci -m "added branches under test_tag"

##########################################
echo ""
echo "* PERFORM HG CLONE"
cd ../..
hg clone --config extensions.hgsubversion= file://`pwd`/repo/test hg-clone
