#!/bin/bash

# Edit to point to the svnadmin and svn to test.
SVN_HOME=/Users/gglouser/Desktop/downloads/subversion-1.4.2/subversion
SVNADMIN=$SVN_HOME/svnadmin/svnadmin
SVN=$SVN_HOME/svn/svn

REPO=testrepo
WORKING_DIR=testwd
HG_REPO=test-hg

TESTDIR=`pwd`
REPO_URL=file://$TESTDIR/$REPO
HG_SRC=$REPO_URL/proj2

$SVNADMIN create $REPO
$SVN co $REPO_URL $WORKING_DIR

(
    cd $WORKING_DIR

    # set up the original in project 1
    # hgsubversion wants a standard layout, so we must work in a trunk
    echo "----- CHANGE 1"
    mkdir -p proj1/trunk/A/B/C
    echo "change 1" > proj1/trunk/A/stable.txt
    echo "change 1" > proj1/trunk/A/modify.txt
    echo "change 1" > proj1/trunk/A/B/stable.txt
    echo "change 1" > proj1/trunk/A/B/modify.txt
    echo "change 1" > proj1/trunk/A/B/replace.txt
    echo "change 1" > proj1/trunk/A/B/C/stable.txt
    echo "change 1" > proj1/trunk/A/B/C/modify.txt
    echo "change 1" > proj1/trunk/A/B/C/replace.txt
    $SVN add proj1
    $SVN ci -m "first change"
    $SVN up

    # make a change
    echo "----- CHANGE 2"
    echo "change 2" >> proj1/trunk/A/stable.txt
    echo "change 2" >> proj1/trunk/A/modify.txt
    echo "change 2" >> proj1/trunk/A/B/stable.txt
    echo "change 2" >> proj1/trunk/A/B/modify.txt
    echo "change 2" >> proj1/trunk/A/B/replace.txt
    echo "change 2" >> proj1/trunk/A/B/C/stable.txt
    echo "change 2" >> proj1/trunk/A/B/C/modify.txt
    echo "change 2" >> proj1/trunk/A/B/C/replace.txt
    echo "change 2" > proj1/trunk/A/added_in_2.txt
    echo "change 2" > proj1/trunk/A/B/added_in_2.txt
    echo "change 2" > proj1/trunk/A/B/C/added_in_2.txt
    $SVN add proj1/trunk/A/added_in_2.txt
    $SVN add proj1/trunk/A/B/added_in_2.txt
    $SVN add proj1/trunk/A/B/C/added_in_2.txt
    $SVN ci -m "second change"
    $SVN up

    echo "----- PROJ 1 SETUP COMPLETE"
    $SVN st -v

    echo "----- CREATE PROJ 2"
    $SVN mkdir proj2
    $SVN mkdir proj2/trunk
    $SVN ci -m "created proj2/trunk"
    $SVN up

    # make the complicated copy in project 2
    echo "----- COPY A TO PROJ 2"
    $SVN cp proj1/trunk/A proj2/trunk/
    echo "-----"
    $SVN st -v

    echo "----- REMOVE A/B"
    rm -rf proj2/trunk/A/B
    $SVN rm proj2/trunk/A/B
    echo "-----"
    $SVN st -v

    echo "----- COPY A/B AT REV 1"
    $SVN cp -r 1 proj1/trunk/A/B proj2/trunk/A/
    echo "-----"
    $SVN st -v

    echo "----- GET FILES ADDED IN REV 2"
    $SVN cp -r 2 proj1/trunk/A/B/added_in_2.txt proj2/trunk/A/B/
    $SVN cp -r 2 proj1/trunk/A/B/C/added_in_2.txt proj2/trunk/A/B/C/
    echo "-----"
    $SVN st -v

    echo "----- REPLACE FILES AT REV 2"
    $SVN rm proj2/trunk/A/B/replace.txt
    $SVN cp -r 2 proj1/trunk/A/B/replace.txt proj2/trunk/A/B/
    $SVN rm proj2/trunk/A/B/C/replace.txt
    $SVN cp -r 2 proj1/trunk/A/B/C/replace.txt proj2/trunk/A/B/C/
    echo "-----"
    $SVN st -v

    echo "----- MODIFY FILES"
    echo "change 3" >> proj2/trunk/A/modify.txt
    echo "change 3" >> proj2/trunk/A/B/modify.txt
    echo "change 3" >> proj2/trunk/A/B/C/modify.txt
    echo "-----"
    $SVN st -v

    echo "----- ADD FILES"
    echo "change 3" >> proj2/trunk/A/added.txt
    echo "change 3" >> proj2/trunk/A/B/added.txt
    echo "change 3" >> proj2/trunk/A/B/C/added.txt
    $SVN add proj2/trunk/A/added.txt
    $SVN add proj2/trunk/A/B/added.txt
    $SVN add proj2/trunk/A/B/C/added.txt
    echo "-----"
    $SVN st -v

    echo "----- COMMIT"
    $SVN ci -m "the mad copy"
    $SVN up

    # And let's see the record of what happened.
    echo "----- FINAL LOG"
    $SVN log -v
)

echo "----- ATTEMPT hg svnclone"
hg svnclone $HG_SRC $HG_REPO
